<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="物资" prop="materialId">
        <el-input v-model="queryParams.materialId" placeholder="请输入物资ID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="预警级别" prop="alertLevel">
        <el-select v-model="queryParams.alertLevel" placeholder="请选择预警级别">
          <el-option v-for="item in alert_level" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="预警类型" prop="alertType">
        <el-select v-model="queryParams.alertType" placeholder="请选择预警类型">
          <el-option v-for="item in alarm_type" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="处理状态" prop="alertStatus">
        <el-select v-model="queryParams.alertStatus" placeholder="请选择处理状态">
          <el-option v-for="item in alert_status" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="wmsAlertRecordList" @selection-change="handleSelectionChange">
      <el-table-column label="规则" align="center" prop="alertRule.ruleName" />
      <el-table-column label="预警类型" align="center" prop="alertType">
        <template #default="scope">
          <dict-tag :options="alarm_type" :value="scope.row.alertType" />
        </template>
      </el-table-column>
      <el-table-column label="物资" align="center" prop="material.materialName" />
      <el-table-column label="仓库/库区/货架" align="center" prop="warehouseId" width="120">
        <template #default="scope">
          <span v-if="scope.row.warehouse?.warehouseName || scope.row.area?.areaName || scope.row.location?.locationName">
            {{ scope.row.warehouse?.warehouseName || '-' }}/
            {{ scope.row.area?.areaName || '-' }}/
            {{ scope.row.location?.locationName || '-' }}
          </span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="当前值" align="center" prop="currentValue" />
      <el-table-column label="阈值" align="center" prop="thresholdValue" />
      <el-table-column label="预警时间" align="center" prop="alertTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.alertTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="预警级别" align="center" prop="alertLevel">
        <template #default="scope">
          <dict-tag :options="alert_level" :value="scope.row.alertLevel" />
        </template>
      </el-table-column>
      <el-table-column label="预警信息" align="center" prop="alertMessage" width="260" />
      <el-table-column label="处理状态" align="center" prop="alertStatus">
        <template #default="scope">
          <dict-tag :options="alert_status" :value="scope.row.alertStatus" />
        </template>
      </el-table-column>
      <el-table-column label="处理人" align="center" prop="handlerId" width="180">
        <template #default="scope">
          <span v-if="scope.row.handler">{{ scope.row.handler?.nickName || '-' }} | {{ scope.row.handler?.phonenumber || '-' }}</span>
        </template>
      </el-table-column>
      <el-table-column label="处理时间" align="center" prop="handleTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.handleTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="处理结果" align="center" prop="handleResult" width="120" />

      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="160">
        <template #default="scope">
          <el-button link type="primary" @click="handleDetail(scope.row)"
            v-hasPermi="['ware:wmsAlertRecord:detail']">详情</el-button>
          <el-button link type="primary" @click="handleHandle(scope.row)"
            v-hasPermi="['ware:wmsAlertRecord:handle']">处理</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改预警记录对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="wmsAlertRecordRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="规则ID" prop="ruleId">
          <el-input v-model="form.ruleId" placeholder="请输入规则ID" />
        </el-form-item>
        <el-form-item label="物资ID" prop="materialId">
          <el-input v-model="form.materialId" placeholder="请输入物资ID" />
        </el-form-item>
        <el-form-item label="仓库ID" prop="warehouseId">
          <el-input v-model="form.warehouseId" placeholder="请输入仓库ID" />
        </el-form-item>
        <el-form-item label="货架ID" prop="locationId">
          <el-input v-model="form.locationId" placeholder="请输入货架ID" />
        </el-form-item>
        <el-form-item label="当前值" prop="currentValue">
          <el-input v-model="form.currentValue" placeholder="请输入当前值" />
        </el-form-item>
        <el-form-item label="阈值" prop="thresholdValue">
          <el-input v-model="form.thresholdValue" placeholder="请输入阈值" />
        </el-form-item>
        <el-form-item label="预警级别" prop="alertLevel">
          <el-input v-model="form.alertLevel" placeholder="请输入预警级别" />
        </el-form-item>
        <el-form-item label="预警信息" prop="alertMessage">
          <el-input v-model="form.alertMessage" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="处理人" prop="handlerId">
          <el-input v-model="form.handlerId" placeholder="请输入处理人" />
        </el-form-item>
        <el-form-item label="处理时间" prop="handleTime">
          <el-date-picker clearable v-model="form.handleTime" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择处理时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="处理结果" prop="handleResult">
          <el-input v-model="form.handleResult" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="预警时间" prop="alertTime">
          <el-date-picker clearable v-model="form.alertTime" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择预警时间">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>

    <!-- 详情对话框 -->
    <DetailInfo v-model:visible="detailOpen" :record-info="detailForm" @update:visible="val => detailOpen = val" />

    <!-- 处理对话框 -->
    <HandleAlert :visible="handleOpen" :record-info="handleForm" @update:visible="val => handleOpen = val"
      @handle-success="getList" />
  </div>
</template>

<script setup name="WmsAlertRecord">
import { listWmsAlertRecord, getWmsAlertRecord, delWmsAlertRecord, addWmsAlertRecord, updateWmsAlertRecord } from "@/api/ware/wmsAlertRecord"
import HandleAlert from './components/HandleAlert.vue'
import DetailInfo from './components/DetailInfo.vue'

const { proxy } = getCurrentInstance()

const { alert_status, alert_level, alarm_type } = proxy.useDict('alert_status', 'alert_level', 'alarm_type')

const wmsAlertRecordList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")
// 详情对话框
const detailOpen = ref(false)
const detailForm = ref({})
// 处理对话框
const handleOpen = ref(false)
const handleForm = ref({})

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    ruleId: null,
    alertType: null,
    materialId: null,
    warehouseId: null,
    locationId: null,
    currentValue: null,
    thresholdValue: null,
    alertLevel: null,
    alertMessage: null,
    alertStatus: null,
    handlerId: null,
    handleTime: null,
    handleResult: null,
    alertTime: null
  },
  rules: {
    ruleId: [
      { required: true, message: "规则ID不能为空", trigger: "blur" }
    ],
    alertType: [
      { required: true, message: "预警类型不能为空", trigger: "change" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询预警记录列表 */
function getList() {
  loading.value = true
  listWmsAlertRecord(queryParams.value).then(response => {
    wmsAlertRecordList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    recordId: null,
    ruleId: null,
    alertType: null,
    materialId: null,
    warehouseId: null,
    locationId: null,
    currentValue: null,
    thresholdValue: null,
    alertLevel: null,
    alertMessage: null,
    alertStatus: null,
    handlerId: null,
    handleTime: null,
    handleResult: null,
    alertTime: null
  }
  proxy.resetForm("wmsAlertRecordRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.recordId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加预警记录"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _recordId = row.recordId || ids.value
  getWmsAlertRecord(_recordId).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改预警记录"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["wmsAlertRecordRef"].validate(valid => {
    if (valid) {
      if (form.value.recordId != null) {
        updateWmsAlertRecord(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addWmsAlertRecord(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _recordIds = row.recordId || ids.value
  proxy.$modal.confirm('是否确认删除预警记录编号为"' + _recordIds + '"的数据项？').then(function () {
    return delWmsAlertRecord(_recordIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('ware/wmsAlertRecord/export', {
    ...queryParams.value
  }, `wmsAlertRecord_${new Date().getTime()}.xlsx`)
}

/** 详情按钮操作 */
function handleDetail(row) {
  detailForm.value = row
  detailOpen.value = true
}

/** 处理按钮操作 */
function handleHandle(row) {
  handleForm.value = row
  handleOpen.value = true
}

getList()
</script>
